//
//  Visual Studio inline Assembly code to execute atomic instructions.
//  
//  Project: Thread optimized Ring Buffer 
//  Author: Dennis Lang
//  lang.dennis @ comcast.net 
//  http://home.comcast.net/~lang.dennis/
//

typedef unsigned int Atomic_t;
inline int AtomicAdd(Atomic_t *addr, Atomic_t ivalue) 
{
    __asm mov eax, ivalue;
    __asm lock add addr, eax;
    // return eax
}

inline void AtomicInc(Atomic_t *addr) 
{
    __asm lock inc addr;
}

inline Atomic_t AtomicTestAndSet(Atomic_t *addr, Atomic_t value, Atomic_t compare) 
{
    __asm mov eax, compare;
    __asm mov ebx, value;
    __asm cmpxchg addr, ebx;
    // return eax;
}

class AsmAtomic
{
    Atomic_t Exchange(Atomic_t value)
    {
        return AtomicTestAndSet(m_value, value, !value);
    }

    Atomic_t    m_value;
};